package RNA::Auth::Movabletype;
#=============================================================================
# Copyright (C) 2003           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================
# Authentication Module (for Movabletype)
# 
# 　認証用モジュール (Movabletype 用)
#=============================================================================

use strict;
use CGI::Carp;
use Net::Blogger;

use vars qw($VERSION);

$VERSION = '0.1';

# $auth = new RNA::Auth::Movabletype(server=>'http://***/mt-xmlrpc.cgi', blogID=>4);
sub new {
	my $class = shift;
	my $self = {};
	
	bless $self, $class;
	
	$self->init(@_);
	
	return $self;
}


sub init {
	my $self = shift;
	my %hash = @_;

	$self->_reset;

	$hash{server} || croak "RPC Server URI is required.";

	$self->{_server} = $hash{server};
	$self->{_blogID} = $hash{blogID};
}


# $self->_reset
sub _reset
{
	my $self = shift;
}


# $bool = $self->check($username, $passwd);
sub check
{
	my $self = shift;
	my ($username, $passwd) = @_;

	my $mt = Net::Blogger->new(engine=>"movabletype");
	$mt->Proxy($self->{_server});
	$mt->Username($username);
	$mt->Password($passwd);
	$mt->BlogId($self->{_blogID});

	return $mt->mt()->getCategoryList() ? 1 : 0;
}

# $bool = $self->add_user($username, $passwd);
sub add_user
{
	my $self = shift;
	my ($username, $passwd) = @_;

	return 0;
}

# $bool = $self->update_user($username, $passwd);
sub update_user
{
	my $self = shift;
	my ($username, $passwd) = @_;

	return 0;
}

# $bool = $self->delete_user($username);
sub delete_user
{
	my $self = shift;
	my ($username) = @_;

	return 0;
}



#=============================================================================
1;
__END__


#!/usr/bin/perl

use strict;
use lib qw(lib extlib);

use RNA::Auth::Movabletype;

my $auth = new RNA::Auth::Movabletype(server=>'http://www.semblog.org/mt/mt-xmlrpc.cgi', blogID=>4);

print $auth->check('', '') ? 'success' : 'fail';
