package RNA::FOAF::Person;
#=============================================================================
# Copyright (C) 2003           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================
# FOAF 𗘗p邽߂̃W[
#==============================================================================

use strict;
use vars qw($VERSION);

$VERSION = '0.1';

BEGIN {
	#----------------------
	# make sub routine
	#----------------------

	# foaf
	# $person->name
	foreach my $el ('name', 'nick', 'mbox', 'mbox_sha1sum', 'homepage', 'weblog') {
		eval "sub $el {return \$_[0]->{$el}\;}";
	}

	# semblog
	# $person->rna, foaftb
	foreach my $el ('rna', 'foaftb') {
		eval "sub $el {return \$_[0]->{semblog}->{$el}\;}";
	}

}

# $person = new RNA::FOAF::Person(
#	name => '',
#	nick => '',
#	mbox => '',
#	mbox_sha1sum => '',
#	knows => [
#		{
#			name => '',
#			mbox_sha1sum => '',
#		},
#		{},
#		...
#	]
#);
sub new {
	my $class = shift;
	my $self = {};
	%{$self} = @_;

	bless $self, $class;

	#$self->{rdfs}->{seeAlso} ||= [];
	$self->{knows} ||= [];
	
	return $self;
}

# $self->clear_knows;
sub clear_knows
{
	my $self = shift;
	$self->{knows} = [];
}

# rdfs
# $person->seeAlso
sub seeAlso
{
	my $self = shift;

	return $self->{rdfs}->{seeAlso};
}


# semblog:foaftb
# $person->trackback_uri
sub trackback_uri
{
	my $self = shift;

	return $self->foaftb;
}


# $array_ref = $self->knows;
sub knows
{
	my $self = shift;
	return $self->{knows};
}

# $self->add_item(prefix=>'rdfs', element=>'seeAlso', value=>'http://...');
sub add_item
{
	my $self = shift;
	my %hash = @_;

	if($hash{prefix}) {
		$self->{$hash{prefix}}->{$hash{element}} = $hash{value};
	}
	else {
	# <foaf:***>
		$self->{$hash{element}} = $hash{value};
	}
}

#=============================================================================
1;
__END__

