package RNA::PlatformDep;
#=============================================================================
# Copyright (C) 2003           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================
#
# プラットフォームに依存する部分を吸収するモジュール
#=============================================================================

use strict;
use Carp;
use File::Spec;

use vars qw($VERSION);

$VERSION = '0.1';


BEGIN {
	my %PERL_VERSION = (
		bytes => 5.006
	);

	while( my($mod, $ver) = each %PERL_VERSION) {
		eval "require $ver\; require $mod\;";
		if($@) {
#	 print STDERR "module [$mod] does not exist\n";
			my $alternate_mod = __PACKAGE__; # . "::$mod";
			eval "require $alternate_mod\;";
			$INC{File::Spec->catfile(split(/::/, $mod)) . '.pm'}
				= $INC{File::Spec->catfile(split(/::/, $alternate_mod)) . '.pm'};
		}
		else {
# print STDERR "module [$mod] exists\n";
		}
# map {print STDERR $_  . " : " . $INC{$_} . "\n"} keys %INC;
	}
}

#=============================================================================
package bytes; # bytes プラグマの代替モジュール




#=============================================================================
1;
__END__

