#!/usr/bin/perl
#=============================================================================
# RNA Ping Reception
#=============================================================================
#
# TrackBack Ping を受け付け，アンテナを更新するスクリプト
#
#=============================================================================
# Copyright (C) 2003           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================

# ライブラリ
use strict;
use lib qw(lib extlib);
use CGI;
use RNA;

my $cgi = new CGI;

#----------------------------------
# 基本設定
#----------------------------------
my $self_uri = $cgi->self_url();

#==============================================================================
# main
#==============================================================================

my $rna = RNA->new(Config => './config.pl');


#-----------------------------------
# Ping 元の情報
#-----------------------------------
my %ping_client = ();
$ping_client{title} = $cgi->param('title');
$ping_client{excerpt} = $cgi->param('excerpt');
$ping_client{url} = $cgi->param('url');
$ping_client{blog_name} = $cgi->param('blog_name');

my $mode = $cgi->param('__mode');

#-----------------------------------
# レスポンス （XML）
#-----------------------------------
print $cgi->header(-type=>'text/xml', -charset => $rna->{Config}->{Encoding});
my $response = &response(0, 'Error', $mode);


#-----------------------------------
# アンテナの更新
#-----------------------------------
if($mode ne 'rss'){
	$rna->run(Mode=>'Ping', TransferURI => '', Response => $response);
}
else {
	print $response;
}


#=============================================================================
# サブルーチン
#=============================================================================


# $str = &response($error, $msg, $mode)
# 	$error : <error>タグに対応．正常 0，エラー 1
#	$msg   : メッセージ
#	$mode  : rss の場合は一覧表示
sub response
{
	my ($error, $msg, $mode) = @_;
	
	my $res = '';
	my $encoding = $rna->{Config}->{Encoding};
	
	$res .= qq(<?xml version="1.0" encoding="$encoding"?>
<response>
<error>$error</error>
);

	if($error) {
		$res .= "<message>$msg</message>\n";
	}
	elsif($mode eq 'rss'){
		$res .= qq(<rss version="0.91"><channel>
<title>$rna->{Config}->{MainIndex}->{Title}</title>
<link>$rna->{Config}->{MainIndex}->{URI}</link>
<description>$rna->{Config}->{MainIndex}->{Description}</description>
<language>$rna->{Config}->{Language}</language>
</channel></rss>
);
	}

# 上の </channel> の前にはさむ．現在はなし
# 
#<item>
#<title>タイトル</title>
#<link>リンク</link>
#<description>Excerpt</description>
#</item>
#
	
	$res .= "</response>\n";

	return $res;
}
